﻿/////////////////////////////////////////////////////////////////////
///
/// This is part of the Tech3 Demo API by Hannes Anders
/// 
///             http://tech.myhannes.info
///
/// You can modify and share this code, however i would be
/// pleased to see some kind of refrence to http://tech.myhannes.info
/// if you decide to use this lib in any of your programs.
/// 
/// 
/// I cannot be held reponsible for any unexpected behaviour of this
/// Software. You use this software at your own risk.
/// 
/// Many thanks to RR2DO2, zinx and reya1p for their great help!
/// 
/////////////////////////////////////////////////////////////////////

namespace Examples
{
    /// <summary>
    /// Represents the Teams in Enemy Territory
    /// </summary>
    enum ET_Team
    {
        NONE,
        AXIS,
        ALLIED,
        SPECTATOR
    };

    /// <summary>
    /// ET Entity Types
    /// </summary>
    enum ET_EntityTypes
    {
        ET_GENERAL,
        ET_PLAYER,
        ET_ITEM,
        ET_MISSILE,
        ET_MOVER,
        ET_BEAM,
        ET_PORTAL,
        ET_SPEAKER,
        ET_PUSH_TRIGGER,
        ET_TELEPORT_TRIGGER,
        ET_INVISIBLE,
        ET_CONCUSSIVE_TRIGGER,
        ET_OID_TRIGGER,
        ET_EXPLOSIVE_INDICATOR,
        ET_EXPLOSIVE,
        ET_EF_SPOTLIGHT,
        ET_ALARMBOX,
        ET_CORONA,
        ET_TRAP,
        ET_GAMEMODEL,
        ET_FOOTLOCKER,
        ET_FLAMEBARREL,
        ET_FP_PARTS,
        ET_FIRE_COLUMN,
        ET_FIRE_COLUMN_SMOKE,
        ET_RAMJET,
        ET_FLAMETHROWER_CHUNK,
        ET_EXPLO_PART,
        ET_PROP,
        ET_AI_EFFECT,
        ET_CAMERA,
        ET_MOVERSCALED,
        ET_CONSTRUCTIBLE_INDICATOR,
        ET_CONSTRUCTIBLE,
        ET_CONSTRUCTIBLE_MARKER,
        ET_BOMB,
        ET_WAYPOINT,
        ET_BEAM_2,
        ET_TANK_INDICATOR,
        ET_TANK_INDICATOR_DEAD,
        ET_BOTGOAL_INDICATOR,
        ET_CORPSE,
        ET_SMOKER,
        ET_TEMPHEAD,
        ET_MG42_BARREL,
        ET_TEMPLEGS,
        ET_TRIGGER_MULTIPLE,
        ET_TRIGGER_FLAGONLY,
        ET_TRIGGER_FLAGONLY_MULTIPLE,
        ET_GAMEMANAGER,
        ET_AAGUN,
        ET_CABINET_H,
        ET_CABINET_A,
        ET_HEALER,
        ET_SUPPLIER,
        ET_LANDMINE_HINT,
        ET_ATTRACTOR_HINT,
        ET_SNIPER_HINT,
        ET_LANDMINESPOT_HINT,
        ET_COMMANDMAP_MARKER,
        ET_WOLF_OBJECTIVE,
        ET_EVENTS
    };

    /// <summary>
    /// ET Event Types
    /// </summary>
    public enum ET_EventType
    {
        EV_NONE,
        EV_FOOTSTEP,
        EV_FOOTSTEP_METAL,
        EV_FOOTSTEP_WOOD,
        EV_FOOTSTEP_GRASS,
        EV_FOOTSTEP_GRAVEL,
        EV_FOOTSTEP_ROOF,
        EV_FOOTSTEP_SNOW,
        EV_FOOTSTEP_CARPET,
        EV_FOOTSPLASH,
        EV_FOOTWADE,
        EV_SWIM,
        EV_STEP_4,
        EV_STEP_8,
        EV_STEP_12,
        EV_STEP_16,
        EV_FALL_SHORT,
        EV_FALL_MEDIUM,
        EV_FALL_FAR,
        EV_FALL_NDIE,
        EV_FALL_DMG_10,
        EV_FALL_DMG_15,
        EV_FALL_DMG_25,
        EV_FALL_DMG_50,
        EV_JUMP,
        EV_WATER_TOUCH,	// foot touches
        EV_WATER_LEAVE,	// foot leaves
        EV_WATER_UNDER,	// head touches
        EV_WATER_CLEAR,	// head leaves
        EV_ITEM_PICKUP,			// normal item pickups are predictable
        EV_ITEM_PICKUP_QUIET,	// (SA) same, but don't play the default pickup sound as it was specified in the ent
        EV_GLOBAL_ITEM_PICKUP,	// powerup / team sounds are broadcast to everyone
        EV_NOAMMO,
        EV_WEAPONSWITCHED,
        EV_EMPTYCLIP,
        EV_FILL_CLIP,
        EV_MG42_FIXED, // JPW NERVE
        EV_WEAP_OVERHEAT,
        EV_CHANGE_WEAPON,
        EV_CHANGE_WEAPON_2,
        EV_FIRE_WEAPON,
        EV_FIRE_WEAPONB,
        EV_FIRE_WEAPON_LASTSHOT,
        EV_NOFIRE_UNDERWATER,
        EV_FIRE_WEAPON_MG42,
        EV_FIRE_WEAPON_MOUNTEDMG42,
        EV_ITEM_RESPAWN,
        EV_ITEM_POP,
        EV_PLAYER_TELEPORT_IN,
        EV_PLAYER_TELEPORT_OUT,
        EV_GRENADE_BOUNCE,		// eventParm will be the soundindex
        EV_GENERAL_SOUND,
        EV_GENERAL_SOUND_VOLUME,
        EV_GLOBAL_SOUND,		// no attenuation
        EV_GLOBAL_CLIENT_SOUND,	// DHM - Nerve :: no attenuation, only plays for specified client
        EV_GLOBAL_TEAM_SOUND,	// no attenuation, team only
        EV_FX_SOUND,
        EV_BULLET_HIT_FLESH,
        EV_BULLET_HIT_WALL,
        EV_MISSILE_HIT,
        EV_MISSILE_MISS,
        EV_RAILTRAIL,
        EV_VENOM,
        EV_BULLET,				// otherEntity is the shooter
        EV_LOSE_HAT,			//----(SA)	
        EV_PAIN,
        EV_CROUCH_PAIN,
        EV_DEATH1,
        EV_DEATH2,
        EV_DEATH3,
        EV_OBITUARY,
        EV_STOPSTREAMINGSOUND, // JPW NERVE swiped from sherman
        EV_POWERUP_QUAD,
        EV_POWERUP_BATTLESUIT,
        EV_POWERUP_REGEN,
        EV_GIB_PLAYER,			// gib a previously living player
        EV_DEBUG_LINE,
        EV_STOPLOOPINGSOUND,
        EV_TAUNT,
        EV_SMOKE,
        EV_SPARKS,
        EV_SPARKS_ELECTRIC,
        EV_EXPLODE,		// func_explosive
        EV_RUBBLE,
        EV_EFFECT,		// target_effect
        EV_MORTAREFX,	// mortar firing
        EV_SPINUP,	// JPW NERVE panzerfaust preamble
        EV_SNOW_ON,
        EV_SNOW_OFF,
        EV_MISSILE_MISS_SMALL,
        EV_MISSILE_MISS_LARGE,
        EV_MORTAR_IMPACT,
        EV_MORTAR_MISS,
        EV_SPIT_HIT,
        EV_SPIT_MISS,
        EV_SHARD,
        EV_JUNK,
        EV_EMITTER,	//----(SA)	added // generic particle emitter that uses client-side particle scripts
        EV_OILPARTICLES,
        EV_OILSLICK,
        EV_OILSLICKREMOVE,
        EV_MG42EFX,
        EV_FLAKGUN1,
        EV_FLAKGUN2,
        EV_FLAKGUN3,
        EV_FLAKGUN4,
        EV_EXERT1,
        EV_EXERT2,
        EV_EXERT3,
        EV_SNOWFLURRY,
        EV_CONCUSSIVE,
        EV_DUST,
        EV_RUMBLE_EFX,
        EV_GUNSPARKS,
        EV_FLAMETHROWER_EFFECT,
        EV_POPUP,
        EV_POPUPBOOK,
        EV_GIVEPAGE,
        EV_MG42BULLET_HIT_FLESH,	// Arnout: these two send the seed as well
        EV_MG42BULLET_HIT_WALL,
        EV_SHAKE,
        EV_DISGUISE_SOUND,
        EV_BUILDDECAYED_SOUND,
        EV_FIRE_WEAPON_AAGUN,
        EV_DEBRIS,
        EV_ALERT_SPEAKER,
        EV_POPUPMESSAGE,
        EV_ARTYMESSAGE,
        EV_AIRSTRIKEMESSAGE,
        EV_MEDIC_CALL,
        EV_MAX_EVENTS	// just added as an 'endcap'
    };

    /// <summary>
    /// ET Weapons
    /// </summary>
    public enum ET_MeanOfDeath
    {
        MOD_UNKNOWN,
        MOD_MACHINEGUN,
        MOD_BROWNING,
        MOD_MG42,
        MOD_GRENADE,
        MOD_ROCKET,

        // (SA) modified wolf weap mods
        MOD_KNIFE,
        MOD_LUGER,
        MOD_COLT,
        MOD_MP40,
        MOD_THOMPSON,
        MOD_STEN,
        MOD_GARAND,
        MOD_SNOOPERSCOPE,
        MOD_SILENCER,	//----(SA)	
        MOD_FG42,
        MOD_FG42SCOPE,
        MOD_PANZERFAUST,
        MOD_GRENADE_LAUNCHER,
        MOD_FLAMETHROWER,
        MOD_GRENADE_PINEAPPLE,
        MOD_CROSS,
        // end

        MOD_MAPMORTAR,
        MOD_MAPMORTAR_SPLASH,

        MOD_KICKED,
        MOD_GRABBER,

        MOD_DYNAMITE,
        MOD_AIRSTRIKE, // JPW NERVE
        MOD_SYRINGE,	// JPW NERVE
        MOD_AMMO,	// JPW NERVE
        MOD_ARTY,	// JPW NERVE

        MOD_WATER,
        MOD_SLIME,
        MOD_LAVA,
        MOD_CRUSH,
        MOD_TELEFRAG,
        MOD_FALLING,
        MOD_SUICIDE,
        MOD_TARGET_LASER,
        MOD_TRIGGER_HURT,
        MOD_EXPLOSIVE,

        MOD_CARBINE,
        MOD_KAR98,
        MOD_GPG40,
        MOD_M7,
        MOD_LANDMINE,
        MOD_SATCHEL,
        MOD_TRIPMINE,
        MOD_SMOKEBOMB,
        MOD_MOBILE_MG42,
        MOD_SILENCED_COLT,
        MOD_GARAND_SCOPE,

        MOD_CRUSH_CONSTRUCTION,
        MOD_CRUSH_CONSTRUCTIONDEATH,
        MOD_CRUSH_CONSTRUCTIONDEATH_NOATTACKER,

        MOD_K43,
        MOD_K43_SCOPE,

        MOD_MORTAR,

        MOD_AKIMBO_COLT,
        MOD_AKIMBO_LUGER,
        MOD_AKIMBO_SILENCEDCOLT,
        MOD_AKIMBO_SILENCEDLUGER,

        MOD_SMOKEGRENADE,

        // RF
        MOD_SWAP_PLACES,

        // OSP -- keep these 2 entries last
        MOD_SWITCHTEAM,

        MOD_NUM_MODS
    };
}