﻿/////////////////////////////////////////////////////////////////////
///
/// This is part of the Tech3 Demo API by Hannes Anders
/// 
///             http://tech.myhannes.info
///
/// You can modify and share this code, however i would be
/// pleased to see some kind of refrence to http://tech.myhannes.info
/// if you decide to use this lib in any of your programs.
/// 
/// 
/// I cannot be held reponsible for any unexpected behaviour of this
/// Software. You use this software at your own risk.
/// 
/// Many thanks to RR2DO2, zinx and reya1p for their great help!
/// 
/////////////////////////////////////////////////////////////////////

using Anders.Gaming.DemoDecoder.Core;
using Anders.Gaming.DemoDecoder.Data_Classes;

namespace Examples
{
    public static class Library
    {
        // et fallbacks
        public static string ET_DEMOFILE = @"D:\Games\etwar\etpro\demos\2009-03-13-021843-adlernest-idle7_vs_team-nd.dm_84";
        public static string ET_EXPORTFILE = @"D:\Games\etwar\etpro\demos\kkk.dm_84";

        // q3 fallbacks
        public static string Q3_DEMOFILE = @"D:\Games\Quake3\baseq3\demos\HUN_POL_dm7.dm_68";
        public static string Q3_EXPORTFILE = @"D:\Games\Quake3\baseq3\demos\kkk.dm_68";

        // tv fallbacks
        public static string TV_DEMOFILE = @"D:\Games\etwar\etpro\demos\demo0005.tv_84";
        public static string TV_EXPORTFILE = @"D:\Games\etwar\etpro\demos\kkk.tv_84";


        /// <summary>
        /// Checks if the Entity is a popup event (ET)
        /// </summary>
        /// <param name="ent"> the entity </param>
        /// <returns> true if it is </returns>
        public static bool IsETPopupEvent(Entity ent)
        {
            int evt = -1;

            if (ent.EntityType > (int)ET_EntityTypes.ET_EVENTS)
            {
                evt = ent.EntityType - (int)ET_EntityTypes.ET_EVENTS;
            }

            ET_EventType entEv = (ET_EventType)(evt & ~Tech3Parser.EV_EVENT_BITS);

            if (entEv == ET_EventType.EV_OBITUARY)
            {
                return true;
            }
            return false;
        }

        /// <summary>
        /// Checks if the Entity is a popup event (Q3)
        /// </summary>
        /// <param name="ent"> the entity </param>
        /// <returns> true if it is </returns>
        public static bool IsQ3PopupEvent(Entity ent)
        {
            int evt = -1;

            if (ent.EntityType > (int)Q3_EntityTypes.ET_EVENTS)
            {
                evt = ent.EntityType - (int)Q3_EntityTypes.ET_EVENTS;
            }

            Q3_EventType entEv = (Q3_EventType)(evt & ~Tech3Parser.EV_EVENT_BITS);

            if (entEv == Q3_EventType.EV_OBITUARY)
            {
                return true;
            }
            return false;
        }
    }
}
